Option Explicit

Dim RecvText As String
Dim PrevCode As Integer
Dim DleFlag As Integer
Dim Packet(1024) As String
Dim PacketInx As Integer

Sub CloseCommPort ()
  If (MainForm.CommPort.PortOpen) Then
    MainForm.CommPort.PortOpen = False
  End If
End Sub

Function GetChar () As Integer
  Do While MainForm.CommPort.InBufferCount = 0
    DoEvents
  Loop
  GetChar = 0
End Function

Sub OpenCommPort ()
  CloseCommPort
  PacketInx = 1
  MainForm.CommPort.CommPort = 2
  MainForm.CommPort.Settings = "1200,n,8,1"
  MainForm.CommPort.PortOpen = True
  MainForm.CommPort.InputLen = 1
  MainForm.CommPort.RThreshold = 1
End Sub

Sub SendChar (ch As Integer)
  Do While MainForm.CommPort.OutBufferCount > 0
    DoEvents
  Loop
  MainForm.CommPort.Output = ch
  MainForm.CommPort.InBufferCount = 0
End Sub

Sub SetSpeed (Baud As Integer)
  MainForm.CommPort.Settings = Str(Baud) & ",n,8,1"
End Sub

Function StrToSingle (Start As Integer) As Single
  Dim LongVal As Long
  Dim i As Integer
  Dim SignFlag As Integer
  Dim Exponent As Integer
  Dim Digit1 As Integer, Digit2 As Integer
  Dim Log2 As Single
  Dim Mantissa As Single
  
  Log2 = Log(2)
  Digit1 = Asc(Packet(Start))
  If Digit1 / 128 >= 1 Then
    SignFlag = 1
  Else
    SignFlag = 0
  End If
  Digit2 = Asc(Packet(Start + 1))
  Exponent = (Digit1 Mod 128) * 2
  If Digit2 / 128 >= 1 Then
    Exponent = Exponent + 1
  End If
  Exponent = Exponent - 127 - 23

  Mantissa = 128 + (Digit2 Mod 128)
  Digit2 = Asc(Packet(Start + 2))
  Mantissa = (Mantissa * 256) + Digit2
  Digit2 = Asc(Packet(Start + 3))
  Mantissa = (Mantissa * 256) + Digit2

  If SignFlag = 1 Then
    StrToSingle = -Mantissa * Exp(Exponent * Log2)
  Else
    StrToSingle = Mantissa * Exp(Exponent * Log2)
  End If
End Function

